import { IHypernetCore, RenderError } from "@hypernetlabs/objects";
import { IConnectorAuthorizationFlowParams, IHypernetWebUI, IRenderParams, IRenderPaymentWidgetParams, IOnboardingFlowParams, IViewUtils, IDateUtils } from "../../interfaces";
import { Result } from "neverthrow";
export default class HypernetWebUI implements IHypernetWebUI {
    private static instance;
    protected coreInstance: IHypernetCore;
    protected viewUtils: IViewUtils;
    protected dateUtils: IDateUtils;
    constructor(_coreInstance?: IHypernetCore);
    private _generateDomElement;
    private _removeExistedElement;
    private _bootstrapComponent;
    private _getThrowableRender;
    renderPrivateKeysModal(): Result<void, RenderError>;
    renderMetamaskWarningModal(): Result<void, RenderError>;
    renderWarningAlertModal(errorMessage?: string): Result<void, RenderError>;
    renderBalancesWidget(config?: IRenderParams): Result<void, RenderError>;
    renderMerchantsWidget(config?: IRenderParams): Result<void, RenderError>;
    renderFundWidget(config?: IRenderParams): Result<void, RenderError>;
    renderLinksWidget(config?: IRenderParams): Result<void, RenderError>;
    renderPaymentWidget(config?: IRenderPaymentWidgetParams): Result<void, RenderError>;
    renderPublicIdentifierWidget(config?: IRenderParams): Result<void, RenderError>;
    renderConnectorAuthorizationFlow(config: IConnectorAuthorizationFlowParams): Result<void, RenderError>;
    startOnboardingFlow(config: IOnboardingFlowParams): Result<void, RenderError>;
}
//# sourceMappingURL=HypernetWebUI.d.ts.map