"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@material-ui/core");
const FilterList_1 = __importDefault(require("@material-ui/icons/FilterList"));
const contexts_1 = require("../../contexts");
const interfaces_1 = require("../../interfaces");
const react_1 = __importStar(require("react"));
const components_1 = require("../../components");
const hooks_1 = require("../../hooks");
const LinksWidget = ({ noLabel, includeBoxWrapper, bodyStyle, }) => {
    const { viewUtils, dateUtils } = contexts_1.useStoreContext();
    const [tabValue, setTabValue] = react_1.useState(0);
    const [isSideFilterOpen, setIsSideFilterOpen] = react_1.useState(false);
    const [filter, setFilter] = react_1.useState();
    const { links, publicIdentifier, acceptPayment, disputePayment, pullFunds, loading, paymentsAutoAccept, setPaymentsAutoAccept, } = hooks_1.useLinks();
    const handleChange = (event, newValue) => {
        setTabValue(newValue);
    };
    const linksFilter = react_1.useMemo(() => [
        {
            label: "Search By Payment ID",
            widgetType: interfaces_1.EItemType.stringInput,
            stateKey: "id",
        },
        {
            label: "Search By From",
            widgetType: interfaces_1.EItemType.stringInput,
            stateKey: "from",
        },
        {
            label: "Search By To",
            widgetType: interfaces_1.EItemType.stringInput,
            stateKey: "to",
        },
        {
            label: "Search By Merchant URL",
            widgetType: interfaces_1.EItemType.stringInput,
            stateKey: "merchantUrl",
        },
        {
            label: "Search By Payment State",
            widgetType: interfaces_1.EItemType.select,
            stateKey: "state",
            defaultValue: "all",
            widgetProps: {
                options: viewUtils.getPaymentStateOptions(),
            },
        },
        {
            label: "Search By created date",
            widgetType: interfaces_1.EItemType.dateTimeDifference,
            stateKey: "createdTimestamp",
        },
        {
            label: "Search By expiration date",
            widgetType: interfaces_1.EItemType.dateTimeDifference,
            stateKey: "expirationDate",
        },
    ], []);
    const handleFilterSubmit = (filter) => {
        console.log("handleFilterSubmit filter: ", filter);
        if (!filter)
            return;
        setFilter(filter);
    };
    const getPushPayments = () => {
        return links.reduce((acc, link) => {
            const pushPayments = link.pushPayments.filter((pushPayment) => {
                return (pushPayment.id.includes((filter === null || filter === void 0 ? void 0 : filter.id) || "") &&
                    pushPayment.from.includes((filter === null || filter === void 0 ? void 0 : filter.from) || "") &&
                    pushPayment.to.includes((filter === null || filter === void 0 ? void 0 : filter.to) || "") &&
                    pushPayment.merchantUrl.includes((filter === null || filter === void 0 ? void 0 : filter.merchantUrl) || "") &&
                    ((filter === null || filter === void 0 ? void 0 : filter.state) == null ||
                        (filter === null || filter === void 0 ? void 0 : filter.state) === "all" ||
                        pushPayment.state.toString() == (filter === null || filter === void 0 ? void 0 : filter.state)) &&
                    dateUtils.checkTimestampInRang(pushPayment.createdTimestamp, dateUtils.fromDatetimeStringToTimestamp(filter === null || filter === void 0 ? void 0 : filter.createdTimestampFrom), dateUtils.fromDatetimeStringToTimestamp(filter === null || filter === void 0 ? void 0 : filter.createdTimestampTo)) &&
                    dateUtils.checkTimestampInRang(pushPayment.expirationDate, dateUtils.fromDatetimeStringToTimestamp(filter === null || filter === void 0 ? void 0 : filter.expirationDateFrom), dateUtils.fromDatetimeStringToTimestamp(filter === null || filter === void 0 ? void 0 : filter.expirationDateTo)));
            });
            acc.push(...pushPayments);
            return acc;
        }, new Array());
    };
    const getPullPayments = () => {
        return links.reduce((acc, link) => {
            const pullPayments = link.pullPayments.filter((pullPayment) => {
                return (pullPayment.id.includes((filter === null || filter === void 0 ? void 0 : filter.id) || "") &&
                    pullPayment.from.includes((filter === null || filter === void 0 ? void 0 : filter.from) || "") &&
                    pullPayment.to.includes((filter === null || filter === void 0 ? void 0 : filter.to) || "") &&
                    pullPayment.merchantUrl.includes((filter === null || filter === void 0 ? void 0 : filter.merchantUrl) || "") &&
                    ((filter === null || filter === void 0 ? void 0 : filter.state) == null ||
                        (filter === null || filter === void 0 ? void 0 : filter.state) === "all" ||
                        pullPayment.state.toString() == (filter === null || filter === void 0 ? void 0 : filter.state)) &&
                    dateUtils.checkTimestampInRang(pullPayment.createdTimestamp, dateUtils.fromDatetimeStringToTimestamp(filter === null || filter === void 0 ? void 0 : filter.createdTimestampFrom), dateUtils.fromDatetimeStringToTimestamp(filter === null || filter === void 0 ? void 0 : filter.createdTimestampTo)) &&
                    dateUtils.checkTimestampInRang(pullPayment.expirationDate, dateUtils.fromDatetimeStringToTimestamp(filter === null || filter === void 0 ? void 0 : filter.expirationDateFrom), dateUtils.fromDatetimeStringToTimestamp(filter === null || filter === void 0 ? void 0 : filter.expirationDateTo)));
            });
            acc.push(...pullPayments);
            return acc;
        }, new Array());
    };
    const onPaymentsAutoAcceptChange = (event) => {
        setPaymentsAutoAccept(event.target.checked);
    };
    const CustomBox = includeBoxWrapper ? components_1.BoxWrapper : core_1.Box;
    return (react_1.default.createElement(CustomBox, { label: !noLabel ? "TRANSACTION HISTORY" : undefined, rightComponent: react_1.default.createElement(core_1.Box, { display: "flex", alignItems: "center" },
            react_1.default.createElement(core_1.Box, { display: "flex", alignItems: "center", marginRight: 1 },
                react_1.default.createElement(core_1.Box, { marginRight: 1, color: "#0000008a" }, "Payments auto accept"),
                react_1.default.createElement(core_1.Switch, { checked: paymentsAutoAccept, onChange: onPaymentsAutoAcceptChange, name: "paymentsAutoAccept", color: "primary", inputProps: { "aria-label": "primary checkbox" } })),
            react_1.default.createElement(core_1.IconButton, { "aria-label": "list", onClick: () => setIsSideFilterOpen(true), style: { height: 30, display: "flex", fontSize: 18 } },
                react_1.default.createElement(core_1.Box, { marginRight: 1 }, "Filter"),
                react_1.default.createElement(FilterList_1.default, null))), bodyStyle: bodyStyle, hasEmptyState: links.length === 0 && !loading, emptyState: react_1.default.createElement(components_1.EmptyState, { info: react_1.default.createElement(react_1.default.Fragment, null, "You don't have any payments yet.") }) },
        react_1.default.createElement(components_1.SideFilter, { visible: isSideFilterOpen, onClose: () => setIsSideFilterOpen(false), filterItems: linksFilter, onFilterSubmit: handleFilterSubmit }),
        react_1.default.createElement(core_1.AppBar, { position: "static", color: "transparent", elevation: 0 },
            react_1.default.createElement(components_1.AntTabs, { value: tabValue, onChange: handleChange, indicatorColor: "primary", textColor: "primary" },
                react_1.default.createElement(components_1.AntTab, { label: "Push Payments" }),
                react_1.default.createElement(components_1.AntTab, { label: "Pull Payments" }))),
        react_1.default.createElement(components_1.TabPanel, { value: tabValue, index: 0 },
            react_1.default.createElement(components_1.PushPaymentList, { publicIdentifier: publicIdentifier, pushPayments: getPushPayments(), onAcceptPushPaymentClick: acceptPayment, onDisputePushPaymentClick: disputePayment })),
        react_1.default.createElement(components_1.TabPanel, { value: tabValue, index: 1 },
            react_1.default.createElement(components_1.PullPaymentList, { publicIdentifier: publicIdentifier, pullPayments: getPullPayments(), onAcceptPullPaymentClick: acceptPayment, onDisputePullPaymentClick: disputePayment, onPullFundClick: pullFunds }))));
};
exports.default = LinksWidget;
//# sourceMappingURL=LinksWidget.js.map